Fix ofpath for G5 with multiple drives
[yaboot.git] / ybin / ofpath
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## ofpath: determine OpenFirmware path from unix device node
6 ## Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
7 ##
8 ## Portions based on show_of_path.sh:
9 ##
10 ## Copyright (C) 2000 Olaf Hering <olh@suse.de>
11 ## 
12 ## This program is free software; you can redistribute it and/or
13 ## modify it under the terms of the GNU General Public License
14 ## as published by the Free Software Foundation; either version 2
15 ## of the License, or (at your option) any later version.
16 ##
17 ## This program is distributed in the hope that it will be useful,
18 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ## GNU General Public License for more details.
21 ##
22 ## You should have received a copy of the GNU General Public License
23 ## along with this program; if not, write to the Free Software
24 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
25 ##
26 ###############################################################################
27
28 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
29 PRG="${0##*/}"
30 VERSION=1.0.7
31 DEBUG=0
32 export LC_COLLATE=C
33
34 ## --version output.
35 version()
36 {
37 echo \
38 "$PRG $VERSION
39 Written by Ethan Benson
40 Portions based on show_of_path.sh written by Olaf Hering
41
42 Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
43 Portions Copyright (C) 2000 Olaf Hering
44 This is free software; see the source for copying conditions.  There is NO
45 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
46 }
47
48 ## --help output.
49 usage()
50 {
51 echo \
52 "Usage: $PRG [OPTION]... FILE
53 Find OpenFirmware device path from unix device node.
54
55       --debug                print boring junk only useful for debugging
56   -h, --help                 display this help and exit
57   -V, --version              output version information and exit"
58 }
59
60 ## a small seq replacement, seq is not present on boot/rescue floppies.
61 smallseq()
62 {
63     local v="$1"
64     local n=1
65     echo 1
66     while [ "$v" -gt 1 ] ; do
67         echo "$(($n + 1))"
68         local n="$(($n + 1))"
69         local v="$(($v - 1))"
70     done
71     return 0
72 }
73
74 ## a kludge to replace wc -l, wc is not present on boot/rescue
75 ## floppies. max file is 145 lines, 3 hosts * 16 devs each * 3 lines
76 ## per device, + 1 "Attached Devices:" line.
77 linecount()
78 {
79     if [ $# = 0 ] ; then
80         local file="$(cat)"
81         local v="$file"
82     else
83         local file="$(cat $1)"
84         local v="$file"
85     fi
86
87     if [ -z "$file" ] ; then
88         echo 0
89         return 0
90     fi
91
92     ## use real wc if available
93     if (command -v wc > /dev/null 2>&1) ; then
94         if [ -x `command -v wc` ] ; then
95             lines="$(echo "$file" | wc -l)"
96             if [ $? = 0 ] ; then
97                 echo $lines
98                 unset lines
99                 return 0
100             fi
101         fi
102     fi
103
104     while true ; do
105         for i in `smallseq 145` ; do
106             local b="$(echo "$file" | tail -n $i)"
107             if [ "$v" = "$b" ] ; then
108                 echo "$i"
109                 break 2
110             fi
111         done
112     done
113     return 0
114 }
115
116 ## small tr replacment which handles a specific need of this script.
117 smalltr()
118 {
119     case "$1" in 
120         a) echo 1 ;; b) echo 2 ;; c) echo 3 ;; d) echo 4 ;; e) echo 5 ;; f) echo 6 ;;
121         g) echo 7 ;; h) echo 8 ;; i) echo 9 ;; j) echo 10 ;; k) echo 11 ;; l) echo 12 ;;
122         m) echo 13 ;; n) echo 14 ;; o) echo 15 ;; p) echo 16 ;;
123         1) echo a ;; 2) echo b ;; 3) echo c ;; 4) echo d ;; 5) echo e ;; 
124         6) echo f ;; 7) echo g ;; 8) echo h ;; 9) echo i ;; 10) echo j ;;
125         11) echo k ;; 12) echo l ;; 13) echo m ;; 14) echo n ;; 15) echo o ;;
126         16) echo p ;;
127     esac
128     return 0
129 }
130
131 ## replacment for grep -l which is not supported by busybox grep.
132 ## echo $(cat..) hack needed because busybox grep barfs with `line too
133 ## long' when fed /proc files.  the for loop is needed since busybox
134 ## grep seems to have somewhat broken regexp support.
135 ## usage: lgrep filename regexp regexp ...
136 lgrep()
137 {
138     local f="$1"
139     shift
140     for i in "$@" ; do
141         echo "$(cat "$f")" | grep -q "$i" && echo "$f" && break
142     done
143     return 0
144 }
145
146 ## if readlink is missing use a kludge
147 if (command -v readlink > /dev/null 2>&1) ; then
148     true
149 else
150     readlink()
151     {
152         local SYMTARGET="$(v=`ls -l "$1" 2>/dev/null` ; echo ${v##*> })"
153         if [ -n "$SYMTARGET" ] ; then
154             echo "$SYMTARGET"
155             return 0
156         else
157             return 1
158         fi
159     }
160 fi
161
162 ## a function to print relevant scsi host path when there is more then
163 ## one.  this function also takes care of stripping off the trailing
164 ## /compatible.
165 printhost()
166 {
167     case "$1" in
168         1)
169         echo "${2%/*}"
170         ;;
171         2)
172         echo "${3%/*}"
173         ;;
174         3)
175         echo "${4%/*}"
176         ;;
177         4)
178         echo "${5%/*}"
179         ;;
180     esac
181     return 0
182 }
183
184 ## this finds information we need on both newworld and oldworld macs.
185 ## mainly what scsi host a disk is attached to.
186 scsiinfo()
187 {
188     ## see if system has scsi at all
189     if [ ! -f /proc/scsi/scsi ] ; then
190         local kver="$(uname -r)"
191         case "$kver" in
192             2.5.*|2.6.*)
193                 if [ -d /sys/bus/scsi/devices -a \
194                     -n "$(ls /sys/bus/scsi/devices 2>/dev/null)" ] ; then
195                     echo 1>&2 "$PRG: /proc/scsi/scsi does not exist"
196                     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_SCSI_PROC_FS=y"
197                     return 1
198                 fi
199                 ;;
200         esac
201         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
202         return 1
203     fi
204
205     ## first we have to figure out the SCSI ID, have to do that
206     ## anyway [to] find the attached scsi disks = "Direct-Access" and
207     ## stop at sda=1 sdb=2 or whatever count in 3 lines steps
208
209     ## get last letter of device node, ie sda -> a
210     SUBNODE=${DEVNODE##*sd}
211
212     ## turn SUBNODE above into a number starting at 1, ie a -> 1
213     SUBDEV="$(smalltr $SUBNODE)"
214     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SUBNODE=$SUBNODE SUBDEV=$SUBDEV"
215
216     DEVCOUNT=0
217
218     ## copy scsi file into a variable removing "Attached Devices"
219     ## which is the first line. this avoids a lot of
220     ## [incmopatible] crap later, and improves readability.
221
222     ## find number of lines once and recycle that number, to save
223     ## some time (linecount is a bit slow). subtract one line
224     ## to scrap Attached Devices:
225
226     SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
227
228     if [ "$SUBDEV" -gt "$(cat /proc/scsi/scsi | grep Direct-Access | linecount)" ] ; then
229         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
230         return 1
231     fi
232
233     PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
234
235     for i in $(smallseq $(($SCSILINES / 3))) ; do
236
237         ## put every scsi device into one single line
238         DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
239         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVINFO=$DEVINFO"
240
241         ## cut the type field, expect "Direct-Access" later.
242         DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
243         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVTYPE=$DEVTYPE"
244
245         ## get the device id.
246         DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
247         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVID=$DEVID"
248
249         ## get the scsi host id.
250         DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
251         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVHOST=$DEVHOST"
252
253         if [ "$DEVTYPE" = "Direct-Access" ] ; then
254             DEVCOUNT="$(($DEVCOUNT + 1))"
255             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVCOUNT=$DEVCOUNT"
256             if [ "$SUBDEV" = "$DEVCOUNT" ] ; then
257                 DEVICE_HOST=$DEVHOST
258                 DEVICE_ID=$DEVID
259                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
260                 break
261             fi
262         fi
263     done
264
265     ## figure out what the scsi driver is, it is /proc/scsi/dirname.
266     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
267     SCSI_DRIVER="$(x=`ls /proc/scsi/*/$DEVICE_HOST 2>/dev/null | cat` ; y=`echo ${x##*proc/scsi/}` ; echo ${y%%/*})"
268     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_DRIVER=$SCSI_DRIVER"
269
270     ## figure out which host we found.
271     SCSI_HOSTNUMBER="$(v=`ls /proc/scsi/$SCSI_DRIVER/* 2>/dev/null | cat | grep -n "$DEVICE_HOST\>"` ; echo ${v%%:*})"
272     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_HOSTNUMBER=$SCSI_HOSTNUMBER"
273
274     return 0
275 }
276
277 ## generic function that can find OF device paths for scsi devices,
278 ## must be run after scsiinfo().
279 scsi_ofpath()
280 {
281     case "$SCSI_DRIVER" in
282         aic7xxx)
283             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
284                         lgrep "$i" "^ADPT" "^pci900[45]" "^pciclass,01000" ; done)"
285             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
286             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
287             ;;
288         sym53c8xx)
289             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
290                         lgrep "$i" "^Symbios" "^pci1000" "^pciclass,01000" ; done)"
291             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
292             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
293             ;;
294         mesh)
295             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
296                         lgrep "$i" "mesh" ; done)"
297             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
298             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
299             ;;
300         ata_k2|sata_svw)
301             HOST_LIST="$(for i in `find /proc/device-tree -name compatible ` ; do
302                         lgrep "$i" "k2-sata" ; done | sort)"
303             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
304             echo "${DEVICE_PATH##*device-tree}/disk@0:$PARTITION"
305             ;;
306         *)
307             echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
308             return 1
309             ;;
310     esac
311     return 0
312 }
313
314 ide_ofpath()
315 {
316     if [ ! -L "/proc/ide/$DEVNODE" ] ; then
317         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
318         return 1
319     fi
320
321     local IDEBUS="$(v=`readlink /proc/ide/$DEVNODE` ; echo ${v%%/*} )"
322     if [ -z "$IDEBUS" ] ; then
323         echo 1>&2 "$PRG: BUG: IDEBUS == NULL"
324         return 1
325     fi
326
327     case "$(uname -r)" in
328         2.5.*|2.6.0*|2.6.1|2.6.1-*|2.6.2|2.6.2-*)
329             echo 1>&2 "$PRG: Linux kernel `uname -r` is not supported"
330             return 1
331             ;;
332         2.6.*|2.7.*)
333             if ! (grep -q '.* .* sysfs ' /proc/mounts 2> /dev/null) ; then
334                 echo 1>&2 "$PRG: sysfs must be mounted for ofpath to support this system"
335                 return 1
336             fi
337             local SYS="$(m=`grep '.* .* sysfs ' /proc/mounts | head -n 1` ; echo `d=${m#* };echo ${d%% *}`)"
338             if [ -z "$SYS" -o ! -d "$SYS" ] ; then
339                 echo 1>&2 "$PRG: Unable to determine sysfs mountpoint"
340                 return 1
341             fi
342             local OF1275IDE="${SYS}/block/${DEVNODE}/device/../../devspec"
343             ;;
344         *)
345             local OF1275IDE="/proc/ide/$IDEBUS/devspec"
346             ;;
347     esac
348
349     if [ ! -f "$OF1275IDE" ] ; then
350         case "$(cat /proc/device-tree/model)" in
351             PowerMac3*|PowerMac4*|PowerMac5*|PowerMac6*|PowerMac7*|RackMac*)
352                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
353                 if [ -z "$CDROM" ] ; then
354                     echo 1>&2 "$PRG: WARNING: Your kernel is too old for proper support, device may be innaccurate."
355                     echo "ultra2:$PARTITION"
356                 else
357                     echo "cd:$PARTITION"
358                 fi
359                 ;;
360             *)
361                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
362                 if [ -z "$CDROM" ] ; then
363                     if [ "$DEVNODE" = hda ] ; then
364                         echo "hd:$PARTITION"
365                     else
366                         echo "ultra1:$PARTITION"
367                     fi
368                 else
369                     echo "cd:$PARTITION"
370                 fi
371                 ;;
372         esac
373     else
374         local DEVSPEC="$(cat $OF1275IDE)"
375         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVSPEC=$DEVSPEC"
376         if [ -z "$DEVSPEC" ] ; then
377             echo 1>&2 "$PRG: KERNEL BUG: $OF1275IDE exists, but is empty"
378             return 1
379         fi
380
381         if [ ! -f "/proc/ide/${IDEBUS}/channel" ] ; then
382             echo 1>&2 "$PRG: KERNEL BUG: /proc/ide/${IDEBUS}/channel does not exist"
383             return 1
384         fi
385
386         case "$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)" in
387             ide|ata)
388                 local MASTER="/disk@0"
389                 local SLAVE="/disk@1"
390                 ;;
391             pci-ide|pci-ata)
392                 local MASTER="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@0"
393                 local SLAVE="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@1"
394                 ;;
395             scsi) ## some lame controllers pretend they are scsi, hopefully all kludges are created equal.
396                 local MASTER="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 0))"
397                 local SLAVE="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 1))"
398                 ;;
399             *)
400                 echo 1>&2 "$PRG: Unsupported IDE device type: \"$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)\""
401                 return 1
402                 ;;
403         esac
404
405         case "$DEVNODE" in
406             hda|hdc|hde|hdg|hdi|hdk|hdm|hdo)
407                 echo "${DEVSPEC}${MASTER}:$PARTITION"
408                 return 0
409                 ;;
410             hdb|hdd|hdf|hdh|hdj|hdl|hdn|hdp)
411                 echo "${DEVSPEC}${SLAVE}:$PARTITION"
412                 return 0
413                 ;;
414             *)
415                 echo 1>&2 "$PRG: /dev/$DEVNODE is not supported"
416                 return 1
417                 ;;
418         esac
419     fi
420 }
421
422 ## figure out the OpenFirmware device path for newworld macs.
423 ## sd* scsi disks , hd* ide disks.
424 newworld()
425 {
426     case "$DEVNODE" in
427         sd*)
428             ## use common scsiinfo function to get info we need.
429             scsiinfo || return 1
430
431             ## now we have the data for /@$DEVID:$PARTITION
432             ## find the actual OF path. 
433             scsi_ofpath || return 1
434             ;;
435         hd*)
436             ide_ofpath || return 1
437             ;;
438         *)
439             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
440             return 1
441             ;;
442     esac
443     return 0
444 }
445
446 oldworld()
447 {
448     ## for some reason 2.4 kernels put OF aliases in aliases@0/ instead of plain aliases/
449     if [ -d "/proc/device-tree/aliases" ] ; then
450         local ALIASES="aliases"
451     elif [ -d "/proc/device-tree/aliases@0" ] ; then
452         local ALIASES="aliases@0"
453     else
454         echo 1>&2 "$PRG: Cannot find OpenFirmware aliases directory in /proc/device-tree/"
455         return 1
456     fi
457
458     local MODEL="$(cat /proc/device-tree/compatible)"
459     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: Oldworld subarch: $MODEL"
460
461     case "$MODEL" in
462         AAPL,7300*|AAPL,7500*|AAPL,8500*|AAPL,9500*|AAPL,\?\?\?\?*)
463             case "$DEVNODE" in
464                 sd*)
465                 scsiinfo || return 1
466                 case "$SCSI_DRIVER" in
467                     mesh)
468                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITION
469                     ;;
470                     53c94)
471                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
472                     ;;
473                     *)
474                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
475                     return 1
476                     ;;
477                 esac
478                 ;;
479                 *)
480                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
481                 return 1
482                 ;;
483             esac
484             ;;
485         AAPL,e407*)
486             case "$DEVNODE" in
487                 sd*)
488                 scsiinfo || return 1
489                 case "$SCSI_DRIVER" in
490                     mesh)
491                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
492                     ;;
493                     *)
494                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
495                     return 1
496                     ;;
497                 esac
498                 ;;
499                 hda*)
500                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@0:$PARTITION
501                 ;;
502                 hdb*)
503                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@1:$PARTITION
504                 ;;
505                 hd*)
506                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
507                 ;;
508             esac
509             ;;
510         AAPL,e826*)
511             case "$DEVNODE" in
512                 sd*)
513                 scsiinfo || return 1
514                 case "$SCSI_DRIVER" in
515                     mesh)
516                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
517                     ;;
518                     *)
519                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
520                     return 1
521                     ;;
522                 esac
523                 ;;
524                 hda*)
525                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@0:$PARTITION
526                 ;;
527                 hdb*)
528                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@1:$PARTITION
529                 ;;
530                 hd*)
531                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
532                 ;;
533             esac
534             ;;
535         AAPL,Gossamer*|AAPL,PowerMac\ G3*)
536             case "$DEVNODE" in
537                 sd*)
538                 scsiinfo || return 1
539                 case "$SCSI_DRIVER" in
540                     mesh)
541                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
542                     ;;
543                     *)
544                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
545                     return 1
546                     ;;
547                 esac
548                 ;;
549                 hda*)
550                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@0:$PARTITION
551                 ;;
552                 hdb*)
553                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@1:$PARTITION
554                 ;;
555                 hdc*)
556                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@0:$PARTITION
557                 ;;
558                 hdd*)
559                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@1:$PARTITION
560                 ;;
561                 hd*)
562                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
563                 ;;
564             esac
565             ;;
566         AAPL,PowerBook1998*)
567             if [ -f  /proc/device-tree/$ALIASES/ata0 ] ; then
568                 local ATA0=ata0
569             else
570                 local ATA0=ide0
571             fi
572             if [ -f  /proc/device-tree/$ALIASES/ata1 ] ; then
573                 local ATA1=ata1
574             else
575                 local ATA1=bay-ata1
576             fi
577             case "$DEVNODE" in
578                 sd*)
579                 scsiinfo || return 1
580                 case "$SCSI_DRIVER" in
581                     mesh)
582                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
583                     ;;
584                     *)
585                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
586                     return 1
587                     ;;
588                 esac
589                 ;;
590                 hda*)
591                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@0:$PARTITION
592                 ;;
593                 hdb*)
594                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@1:$PARTITION
595                 ;;
596                 hdc*)
597                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@0:$PARTITION
598                 ;;
599                 hdd*)
600                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@1:$PARTITION
601                 ;;
602                 *)
603                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
604                 return 1
605                 ;;
606             esac
607             ;;
608         AAPL,3400/2400*)
609             case "$DEVNODE" in
610                 sd*)
611                 scsiinfo || return 1
612                 case "$SCSI_DRIVER" in
613                     mesh)
614                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITON
615                     ;;
616                     53c94)
617                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
618                     ;;
619                     *)
620                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
621                     return 1
622                     ;;
623                 esac
624                 ;;
625                 hda*)
626                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@0:$PARTITION
627                 ;;
628                 hdb*)
629                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@1:$PARTITION
630                 ;;
631                 hdc*)
632                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@0:$PARTITION
633                 ;;
634                 hdd*)
635                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@1:$PARTITION
636                 ;;
637                 hde*)
638                 echo $(cat /proc/device-tree/$ALIASES/ata2):$PARTITION
639                 ;;
640                 hdf*)
641                 echo $(cat /proc/device-tree/$ALIASES/ata3):$PARTITION
642                 ;;
643                 *)
644                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
645                 return 1
646                 ;;
647             esac
648             ;;
649         *)
650             echo 1>&2 "$PRG: This machine is not supported: $MODEL"
651             return 1
652             ;;
653     esac
654     return 0
655 }
656
657 ## find OpenFirmware device path for IBM CHRP hardware (scsi only)
658 chrp()
659 {
660     case "$DEVNODE" in
661         sd*)
662             if ls -l /proc/device-tree | grep -q ^lr ; then
663                 true
664             else
665                 echo 1>&2 "$PRG: /proc/device-tree is broken."
666                 return 1
667             fi
668
669             ## use common scsiinfo function to get info we need.
670             scsiinfo || return 1
671
672             ## now we have the data for /@$DEVID:$PARTITION
673             ## find the actual OF path. 
674             scsi_ofpath || return 1
675             ;;
676         *)
677             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
678             return 1
679             ;;
680     esac
681     return 0
682 }
683
684 ## If we get lame devfs name, we need to make it foad
685 ckdevfs()
686 {
687     case "$1" in
688         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
689         return 0
690         ;;
691         *)
692         return 1
693         ;;
694     esac
695 }
696
697 ## convert devfs names into normal short ones, written by Tom Rini.
698 fixdevfs()
699 {
700     ## get partition number, if any
701     local PARTNUM="${1##*[a-z]}"
702     ## Find the bus type.
703     local TYPE="$(v=${1#/dev/} ; echo ${v%/host*})"
704     ## Find the host number.
705     local HOST="$(v=${1#/dev/*/host} ; echo ${v%/bus*})"
706     ## Find the bus number.
707     local BUS="$(v=${1#/dev/*/bus} ; echo ${v%/tar*})"
708     ## Find the target.
709     local TARGET="$(v=${1#/dev/*/target} ; echo ${v%/lun*})"
710
711     case "$TYPE" in
712         ide)
713         case "$HOST" in
714             0)
715             case "$TARGET" in
716                 0)
717                 local DEV=hda
718                 ;;
719                 1)
720                 local DEV=hdb
721                 ;;
722             esac
723             ;;
724             1)
725             case "$TARGET" in
726                 0)
727                 local DEV=hdc
728                 ;;
729                 1)
730                 local DEV=hdd
731                 ;;
732             esac
733             ;;
734             *)
735                 echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
736                 return 1
737         esac
738         local DEV="${DEV}${PARTNUM}"
739         echo "/dev/$DEV"
740         return 0
741         ;;
742         scsi)
743         local LUN="$(v=${1#/dev/*/lun} ; echo ${v%/*})"
744
745         ## In this case, we need to figure out what number our device is
746         local DEVCOUNT=0
747
748         ## copy scsi file into a variable removing "Attached Devices"
749         ## which is the first line. this avoids a lot of
750         ## [incmopatible] crap later, and improves readability.
751
752         ## find number of lines once and recycle that number, to save
753         ## some time (linecount is a bit slow). subtract one line
754         ## to scrap Attached Devices:
755
756         local SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
757         local PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
758
759         for i in $(smallseq $(($SCSILINES / 3))) ; do
760
761             ## put every scsi device into one single line
762             local DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
763             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVINFO=$DEVINFO"
764
765             ## cut the type field, expect "Direct-Access" later.
766             local DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
767             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVTYPE=$DEVTYPE"
768
769             if [ "$DEVTYPE" = "Direct-Access" ] ; then
770                 ## Lets find out some more information
771                 ## get the device id.
772                 local DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
773                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVID=$DEVID"
774
775                 ## get the device lun.
776                 local DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
777                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVLUN=$DEVLUN"
778
779                 ## get the device channel.
780                 local DEVCHAN="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
781                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCHAN=$DEVCHAN"
782
783                 ## get the scsi host id.
784                 local DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
785                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVHOST=$DEVHOST"
786
787                 local DEVCOUNT="$(($DEVCOUNT + 1))"
788                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCOUNT=$DEVCOUNT"
789                 if [ "$DEVHOST" = "$HOST" -a "$DEVCHAN" = "$BUS" -a \
790                     "$DEVID" = "$TARGET" -a "$DEVLUN" = "$LUN" ] ; then
791                     local DEV="sd$(smalltr $DEVCOUNT)${PARTNUM}"
792                     echo "/dev/$DEV"
793                     return 0
794                 fi
795             fi
796         done
797         echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
798         return 1
799         ;;
800         *)
801         echo 1>&2 "$PRG: Unknown bus $TYPE"
802         return 1
803         ;;
804     esac
805     ## we should never get here
806     return 1
807 }
808
809 ## make sure that find, head and tail can be found.  otherwise the
810 ## script will silently give bogus paths.  these are the only /usr/*
811 ## utilities this script depends on.
812 checkutils()
813 {
814     if command -v find > /dev/null 2>&1 ; then
815         [ -x `command -v find` ] || FAIL=1 ; else FAIL=1 ; fi
816     if command -v head > /dev/null 2>&1 ; then
817         [ -x `command -v head` ] || FAIL=1 ; else FAIL=1 ; fi
818     if command -v tail > /dev/null 2>&1 ; then
819         [ -x `command -v tail` ] || FAIL=1 ; else FAIL=1 ; fi
820
821     if [ "$FAIL" = 1 ] ; then
822         echo 1>&2 "$PRG: \`find', \`head', or \`tail' could not be found, aborting."
823         return 1
824     else
825         return 0
826     fi
827 }
828
829 ## parse command line switches.
830 if [ $# != 0 ] ; then
831     while true ; do
832         case "$1" in
833             -V|--version)
834                 version
835                 exit 0
836                 ;;
837             -h|--help)
838                 usage
839                 exit 0
840                 ;;
841             --debug)
842                 DEBUG=1
843                 shift
844                 ;;
845             -*)
846                 echo 1>&2 "$PRG: unrecognized option \`$1'"
847                 echo 1>&2 "$PRG: Try \`$PRG --help' for more information."
848                 exit 1
849                 ;;
850             "")
851                 echo 1>&2 "$PRG: You must specify a filename"
852                 echo 1>&2 "Try \`$PRG --help' for more information."
853                 exit 1
854                 ;;
855             *)
856                 device="$1"
857                 break
858                 ;;
859         esac
860     done
861 else
862     echo 1>&2 "$PRG: You must specify a /dev device"
863     echo 1>&2 "Try \`$PRG --help' for more information."
864     exit 1
865 fi
866
867 ## check that FILE is a block device and exists.
868 if [ ! -e "$device" ] ; then
869     echo 1>&2 "$PRG: $device: No such file or directory"
870     exit 1
871 elif [ ! -b "$device" ] ; then
872     echo 1>&2 "$PRG: $device is not a block device"
873     exit 1
874 fi
875
876 ## check that we are running on a GNU/Linux system, OSX/BSD does not
877 ## have the same /proc stuff
878 if [ `uname -s` != Linux ] ; then
879     echo 1>&2 "$PRG: This utility will only work with GNU/Linux"
880     exit 1
881 fi
882
883 ## check for ppc, i think uname -m is safe for this...
884 if [ `uname -m` != ppc -a `uname -m` != ppc64 ] ; then
885     echo 1>&2 "$PRG: This utility will only work on PowerPC hardware"
886     exit 1
887 fi
888
889 ## ofpath cannot live without procfs
890 if [ ! -f /proc/uptime ] ; then
891     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
892     exit 1
893 fi
894
895 ## check for retarded devfs names and tell them to foad.
896 if ckdevfs "$device" ; then
897     device="$(fixdevfs $device)" || exit 1
898 fi
899
900 ## check for newworld mac. use cat hack due to /proc wierdness.
901 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = NewWorld ] ; then
902     SUBARCH=NewWorld
903 elif [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = OldWorld ] ; then
904     SUBARCH=OldWorld
905 elif (cat /proc/cpuinfo 2>/dev/null | grep ^motherboard | grep -q AAPL) ; then
906     SUBARCH=OldWorld
907 elif (cat /proc/cpuinfo 2> /dev/null | grep ^machine | grep -q 'CHRP IBM') ; then
908     SUBARCH=CHRP
909 else
910     echo 1>&2 "$PRG: This machine is not yet supported"
911     exit 1
912 fi
913
914 ## make sure /proc/device-tree exists
915 if [ ! -d /proc/device-tree ] ; then
916     echo 1>&2 "$PRG: /proc/device-tree does not exist"
917     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_PROC_DEVICETREE=y"
918     exit 1
919 fi
920
921 ## make sure we have what we need.
922 checkutils || exit 1
923
924 ## get the base device node and scrap /dev/ ie /dev/hda2 -> hda
925 DEVICE="${device##*/}"
926 DEVNODE="${DEVICE%%[0-9]*}"
927 PARTITION="${DEVICE##*[a-z]}"
928
929 ## use appropriate search for right sub arch.
930 case "$SUBARCH" in
931     NewWorld)
932         newworld || exit 1
933         ;;
934     OldWorld)
935         oldworld || exit 1
936         ;;
937     CHRP)
938         chrp || exit 1
939         ;;
940 esac
941
942 exit 0